
-- VHDL Test Bench Created from source file pwm_27.vhd -- 19:01:01 01/05/2008
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use work.sim_pkg.all;


ENTITY pwm_27_tb IS
END pwm_27_tb;

ARCHITECTURE behavior OF pwm_27_tb IS 

    COMPONENT pwm_27
    PORT(
        clk : IN std_logic;
        trigger   : in std_logic;                       -- trigger new MUX cycle in sync mode
        sync_mode : in std_logic;                       -- sync mode
        dec_data : IN std_logic_vector(12 downto 0);          
        pwm : OUT std_logic_vector(26 downto 0);
        digits : OUT std_logic_vector(8 downto 0);
        pwm_adr : OUT std_logic_vector(7 downto 0)
        );
    END COMPONENT;

    SIGNAL clk :  std_logic;
    SIGNAL trigger   : std_logic:='0';                       -- trigger new MUX cycle in sync mode
    SIGNAL sync_mode : std_logic:='1';                       -- sync mode
                            
    SIGNAL pwm :  std_logic_vector(26 downto 0);
    SIGNAL digits :  std_logic_vector(8 downto 0);
    SIGNAL pwm_adr :  std_logic_vector(7 downto 0);
    SIGNAL pwm_data :  std_logic_vector(7 downto 0);
    SIGNAL dec_data :  std_logic_vector(12 downto 0);

    constant t_clk : time := 125 ns;

BEGIN

    uut: pwm_27 PORT MAP(
        clk => clk,
        trigger => trigger,
        sync_mode => sync_mode,
        pwm => pwm,
        digits => digits,
        pwm_adr => pwm_adr,
        dec_data => dec_data
    );


-- clock

   process
   BEGIN
     clk <= '0';
     wait for t_clk/2;
     clk <= '1';
     wait for t_clk/2;
   END PROCESS;

-- quick and dirty RAM, just loop address to data with on clock cycle delay

process(clk)
begin
  if rising_edge(clk) then
    pwm_data <= pwm_adr;
  end if;
end process;

-- decoder ROM for nonlinear PWM value translation 

process (clk)
begin
  if rising_edge(clk) then
    dec_data <= pwm_data & "00000";
  end if;
end process;

END;
