
-- VHDL Test Bench Created from source file data_receiver.vhd -- 18:40:35 01/07/2008
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library work;
use work.sim_pkg.all;

ENTITY rec_tb IS
END rec_tb;

ARCHITECTURE behavior OF rec_tb IS 

	COMPONENT data_receiver
	PORT(
		clk : IN std_logic;
		rx_data : IN std_logic;   
		chn_sel : IN std_logic;          
		pwm_data : OUT std_logic_vector(7 downto 0);
		pwm_adr : OUT std_logic_vector(7 downto 0);
		page : OUT std_logic;
		trigger : OUT std_logic;
		we : OUT std_logic
		);
	END COMPONENT;

	SIGNAL clk 					:	std_logic;
	SIGNAL rx_data 	: std_logic:='1';
	SIGNAL chn_sel 	: std_logic:='0';
	SIGNAL pwm_data : std_logic_vector(7 downto 0);
	SIGNAL pwm_adr 	: std_logic_vector(7 downto 0);
	SIGNAL page 				: std_logic;
	SIGNAL trigger 	: std_logic;
	SIGNAL we 						: std_logic;

    constant t_clk : time := 125 ns;
    constant t_bit : time := 4 us;

BEGIN

	uut: data_receiver PORT MAP(
		clk => clk,
		rx_data => rx_data,
	  chn_sel => chn_sel,
		pwm_data => pwm_data,
		pwm_adr => pwm_adr,
		page => page,
		trigger => trigger,
		we => we
	);

-- clock

   process
   BEGIN
     clk <= '0';
     wait for t_clk/2;
     clk <= '1';
     wait for t_clk/2;
   END PROCESS;

-- DMX data stream

process
begin
  wait for 1 ms;
  for j in 1 to 2 loop
    dmx_break(t_bit, rx_data);
    wait for 10 us;
    dmx_write(t_bit, 0, rx_data);
    for i in 1 to 512 loop
      dmx_write(t_bit, i, rx_data);
    end loop;
    wait for 100*t_bit;
  end loop;

  chn_sel <= '1';

  for j in 1 to 2 loop
    dmx_break(t_bit, rx_data);
    wait for 10 us;
    dmx_write(t_bit, 0, rx_data);
    for i in 1 to 512 loop
      dmx_write(t_bit, i, rx_data);
    end loop;
    wait for 100*t_bit;
  end loop;

  wait;
end process;

END;
