--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 


library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

package sim_pkg is
  
-- Declare functions and procedure

   procedure dmx_write (t_bit : in time;
                        data  : in integer;
                        signal dmx   : out std_logic);

   procedure dmx_break (t_bit : in time;
                        signal dmx   : out std_logic);
end sim_pkg;


package body sim_pkg is

   procedure dmx_write (t_bit : in time;
                        data  : in integer;
                        signal dmx   : out std_logic) is

   variable tmp : std_logic_vector(7 downto 0);
   begin
     tmp := conv_std_logic_vector(data,8);
     dmx <= '0';    -- Start bit
     wait for t_bit;
     for i in 0 to 7 loop
        dmx <= tmp(i);
        wait for t_bit;
     end loop;
     dmx <= '1';    -- 2 stop bits
     wait for 2*t_bit;
   end dmx_write;

   procedure dmx_break (t_bit : in time;
                        signal dmx   : out std_logic) is
   begin
     dmx <= '0';
     wait for 22*t_bit;
     dmx <= '1';
     wait for 2*t_bit;
   end dmx_break;
 
end sim_pkg;
